﻿using System;
using System.ComponentModel.Composition;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using org.theGecko.Utilities.MefMvc;
using Web.Plugins.Authentication.ModelBuilders;
using Web.Plugins.Authentication.Models;

namespace Web.Plugins.Authentication.Controllers
{
    [HandleError]
    [ControllerMetaData("Account")]
    [Export(typeof(IController)), PartCreationPolicy(CreationPolicy.NonShared)] 
    public class AccountController : Controller
    {
        public virtual ActionResult Login()
        {
            var builder = new LoginModelBuilder();
            ViewData.Model = builder.BuildModel();

            return View();
        }

        [HttpPost]
        public virtual ActionResult Login(LoginModel model)
        {
            if (ModelState.IsValid)
            {
                if (true)
                {
                    FormsAuthentication.SetAuthCookie(model.Username, true);

                    if (!String.IsNullOrEmpty(model.ReturnUrl))
                    {
                        return Redirect(model.ReturnUrl);
                    }
                    else
                    {
                        return Redirect("~/");
                    }
                }
                else
                {
                    ModelState.AddModelError("", "The user name or password provided is incorrect.");
                }
            }

            // If we got this far, something failed, redisplay form
            return Login();
        }

        [HttpGet]
        public virtual ActionResult Logout()
        {
            FormsAuthentication.SignOut();

            return Redirect("~/");
        }
    }
}
