﻿using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;

namespace Web.Plugins.Authentication.Models
{
    /// <summary>
    /// View model for login form
    /// </summary>
    public class LoginModel
    {
        private string _username;

        [Required]
        [DisplayName("User name")]
        public string Username
        {
            get
            {
                if (string.IsNullOrWhiteSpace(_username))
                {
                    return string.Empty;
                }

                return _username.ToLowerInvariant();
            }
            set
            {
                _username = value;
            }
        }

        [Required]
        [DataType(DataType.Password)]
        [DisplayName("Password")]
        public string Password { get; set; }

        public string ReturnUrl { get; set; }
    }
}