﻿using System.ComponentModel.Composition;
using System.Web.Mvc;
using org.theGecko.Utilities.MefMvc;
using Web.Plugins.Controls.ModelBuilders;

namespace Web.Plugins.Controls.Controllers
{
    [HandleError]
    [ControllerMetaData("Controls")]
    [Export(typeof(IController)), PartCreationPolicy(CreationPolicy.NonShared)]
    public class ControlsController : MefController
    {
        public virtual ActionResult Menu()
        {
            var builder = new MenuModelBuilder(Context.MenuContainer);
            ViewData.Model = builder.BuildModel();

            return View();
        }

        public new virtual ActionResult User()
        {
            var builder = new UserModelBuilder();
            ViewData.Model = builder.BuildModel();

            return View();
        }
    }
}
