﻿using System.Collections.Generic;
using org.theGecko.Utilities.MefMvc;
using Web.Plugins.Controls.Models;

namespace Web.Plugins.Controls.ModelBuilders
{
    public class MenuModelBuilder
    {
        private readonly Menu _menuContainer;

        public MenuModelBuilder(Menu menuContainer)
        {
            _menuContainer = menuContainer;
        }

        public MenuModel BuildModel()
        {
            var model = new MenuModel();
            CreateMenu(model, _menuContainer.Items);

            return model;
        }

        #region Helper Methods

        private void CreateMenu(MenuModel menuModel, IEnumerable<Menu.Item> items)
        {
            foreach (Menu.Item item in items)
            {
                CreateMenu(menuModel, item);
            }
        }

        private void CreateMenu(MenuModel menuModel, Menu.Item item)
        {
            // Add this.
            var menuItem = new MenuItem(item.Title, item.Action, item.Controller);
            menuModel.AddMenuItem(menuItem);

            // Add all of its children.
            CreateMenu(menuItem, item.Items);
        }

        #endregion
    }
}